//
//  TComYuvStatistics.h
//  3DV-HTM
//
//  Created by Fabian Jäger on 15.03.12.
//  Copyright (c) 2012 Institut für Nachrichtentechnik. All rights reserved.
//

/** \file     TComYuvStatistics.h
 \brief    statistics class to analyze mode decisions for CUs
 */

#ifndef _DV_HTM_TComStatistics_h
#define _DV_HTM_TComStatistics_h

#include "CommonDef.h"
#include "TComPic.h"

// ====================================================================================================================
// Class definition
// ====================================================================================================================

class TComYuvStatistics
{
private:
  
  TComPic*          m_pcCurSourcePic;
  TComPicYuv*       m_pcCurTargetPicYuv;
  
  Void xDrawGridPerCU( TComDataCU *pcCU, UInt uiAbsPartIdx, UInt uiDepth );
  Void xFillModesPerCU( TComDataCU *pcCU, UInt uiAbsPartIdx, UInt uiDepth, Bool* m_abMyCodingArgument );
  
  // draw CU grid
  Void xDrawGrid();
  
  // fill modes with color
  Void xFillModes( Bool* m_abMyCodingArgument );
  
protected:
  
public:
  TComYuvStatistics();
  virtual ~TComYuvStatistics();
  
  Void  create                    ();
  Void  init                      ();
  Void  destroy                   ();
  
  // output statistics to file
  Void updateStatistics( TComPic* pcSourcePic, TComPicYuv* pcTargetPicYuv, Bool* m_abMyCodingArgument );
};

#endif
